// FirstGX.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "FirstGX.h"
#include <aygshell.h>

#define MAX_LOADSTRING 100

HINSTANCE			hInst;					// The current instance
HWND				hWnd,hwndCB;			// The command bar handle
WNDCLASS			wc;
BOOL				bRegioned = FALSE;

static SHACTIVATEINFO s_sai;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE, LPTSTR);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
		return FALSE;

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_FIRSTGX);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    //wc.style			= CS_OWNDC;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= NULL;
	//wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_GAPI1));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_FIRSTGX, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);

	//If it is already running, then focus on the window
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		SetForegroundWindow ((HWND) (((DWORD)hWnd) | 0x01));    
		return 0;
	} 

	MyRegisterClass(hInstance, szWindowClass);
	
	RECT	rect;
	GetClientRect(hWnd, &rect);
	
	hWnd = CreateWindow(szWindowClass, 
						szTitle, 
						WS_VISIBLE|WS_OVERLAPPED|WS_SYSMENU,
						CW_USEDEFAULT, 
						CW_USEDEFAULT, 
						200, 
						200, 
						NULL, 
						NULL, 
						hInstance, 
						NULL);

	if (!hWnd)
	{	
		return FALSE;
	}
	
	/*//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	{
		RECT rc;
		GetWindowRect(hWnd, &rc);
		rc.bottom -= MENU_HEIGHT;
		if (hwndCB)
			MoveWindow(hWnd, rc.left, rc.top, rc.right, rc.bottom, FALSE);
	}*/



	return TRUE;
}

// ------------------------------------------------------------------------
// Build a basic region and set it to the window.
// ------------------------------------------------------------------------
void RegionMe()
{
	// --------------------------------------------------
	// create an elliptical region.
	// we use a negative starting y coordinate to make
	// the ellipse cover a bit more of the caption.
	// --------------------------------------------------
	//HRGN hRegion1 = CreateEllipticRgn(20,-20,190,150);
	
	HRGN hRegion1 = CreateRectRgn(0,0,100,100);
	
	// --------------------------------------------------
	// create one more elliptical region in other place.
	// --------------------------------------------------
	//HRGN hRegion2 = CreateEllipticRgn(140,100,300,240);
	HRGN hRegion2 = CreateRectRgn(100,100,200,200);
	
	// --------------------------------------------------
	// combine the two regions to build a new region
	// that will be the sum of the two.
	// the resulting region will be stored in region1,
	// like if we were making something like:
	// hRegion1 = hRegion1 + hRegion2.
	// --------------------------------------------------
	CombineRgn(hRegion1, hRegion1, hRegion2, RGN_OR);
	
	// --------------------------------------------------
	// assign the region to the window
	// --------------------------------------------------
	SetWindowRgn(hWnd, hRegion1, true);
	
	// --------------------------------------------------
	// delete the region objects
	// --------------------------------------------------
	DeleteObject(hRegion1);
	DeleteObject(hRegion2);
	
	// --------------------------------------------------
	// flag just to make sure our app knows about it.
	// --------------------------------------------------
	bRegioned = true;
}



// ------------------------------------------------------------------------
// Remove the region from the window
// ------------------------------------------------------------------------
void UnRegionMe()
{
	// --------------------------------------------------
	// unassign the region
	// --------------------------------------------------
	SetWindowRgn(hWnd, NULL, true);
	
	// --------------------------------------------------
	// flag just to make sure our app knows about it.
	// --------------------------------------------------
	bRegioned = false;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message) 
	{
		case WM_PAINT:
			{
				// -------------------------------------------------
				// tell user to press SPACE to toggle region.
				// -------------------------------------------------
			
				PAINTSTRUCT ps;
				BeginPaint(hWnd,&ps);

				ExtTextOut(ps.hdc, 70,90, ETO_CLIPPED, NULL, L"Press button", 12, NULL);
			
				EndPaint(hWnd,&ps);
			
				break;
			}
		
		case WM_KEYDOWN:

			if (!bRegioned)
				RegionMe();
			else
				UnRegionMe();
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}